blob: bb6b2de2f6c96d55987a8b8b9bd32f3343b28b8c [file] [log] [blame]
Denis Vlasenko7d219aa2006-10-05 10:17:08 +00001#!/bin/sh
2
3debug=false
4
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +00005# Linker flags used:
6#
7# Informational:
8# --warn-common
9# -Map $EXE.map
10# --verbose
11#
12# Optimizations:
13# --sort-common reduces padding
14# --sort-section alignment reduces padding
15# --gc-sections throws out unused sections,
16# does not work for shared libs
Denis Vlasenko42e41822007-10-09 18:01:13 +000017# -On Not used, maybe useful?
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +000018#
19# List of files to link:
20# $l_list == --start-group -llib1 -llib2 --end-group
21# --start-group $O_FILES $A_FILES --end-group
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +000022#
23# Shared library link:
24# -shared self-explanatory
25# -fPIC position-independent code
Denis Vlasenko724d1962007-10-10 14:41:07 +000026# --enable-new-dtags ?
27# -z,combreloc ?
28# -soname="libbusybox.so.$BB_VER"
Denis Vlasenko9b49a5e2007-10-11 10:05:36 +000029# --undefined=lbb_main Seed name to start pulling from
Denis Vlasenko724d1962007-10-10 14:41:07 +000030# (otherwise we'll need --whole-archive)
31# -static Not used, but may be useful! manpage:
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +000032# "... This option can be used with -shared.
33# Doing so means that a shared library
34# is being created but that all of the library's
35# external references must be resolved by pulling
36# in entries from static libraries."
37
38
Denis Vlasenko018e0852007-02-25 00:40:37 +000039try() {
Denis Vlasenko32404742007-10-07 17:05:22 +000040 printf "%s\n" "Output of:" >$EXE.out
41 printf "%s\n" "$*" >>$EXE.out
42 printf "%s\n" "==========" >>$EXE.out
43 $debug && echo "Trying: $*"
Bernhard Reutner-Fischer2dfd2952008-10-23 13:49:21 +000044 $@ >>$EXE.out 2>&1
45 return $?
Denis Vlasenko7d219aa2006-10-05 10:17:08 +000046}
47
Denis Vlasenko130f5592007-11-13 17:36:12 +000048check_cc() {
Denys Vlasenkobca4ea82017-01-24 20:52:42 +010049 tempname="$(mktemp tmp.XXXXXXXXXX)"
Denys Vlasenko51340102015-10-20 16:16:16 +020050 echo "int main(int argc,char**argv){return argv?argc:0;}" >"$tempname".c
Denis Vlasenko0a4624a2008-02-13 07:47:37 +000051 # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
Denys Vlasenko51340102015-10-20 16:16:16 +020052 # Was using "-xc /dev/null", but we need a valid C program.
Denys Vlasenkoedcd5dc2015-10-20 18:15:01 +020053 # "eval" may be needed if CFLAGS can contain
Denys Vlasenko51340102015-10-20 16:16:16 +020054 # '... -D"BB_VER=KBUILD_STR(1.N.M)" ...'
55 # and we need shell to process quotes!
Mike Frysinger77e2bde2015-12-01 11:25:10 -050056 $CC $CFLAGS $LDFLAGS $1 "$tempname".c -o "$tempname" >/dev/null 2>&1
Denys Vlasenkobca4ea82017-01-24 20:52:42 +010057 exitcode=$?
Denys Vlasenko51340102015-10-20 16:16:16 +020058 rm -f "$tempname" "$tempname".c "$tempname".o
Denys Vlasenkobca4ea82017-01-24 20:52:42 +010059 return $exitcode
Denis Vlasenko130f5592007-11-13 17:36:12 +000060}
61
Denis Vlasenko3f9c8482007-12-28 17:04:42 +000062check_libc_is_glibc() {
Denys Vlasenkobca4ea82017-01-24 20:52:42 +010063 tempname="$(mktemp tmp.XXXXXXXXXX)"
Denis Vlasenko3f9c8482007-12-28 17:04:42 +000064 echo "\
65 #include <stdlib.h>
66 /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
67 #if defined(__GLIBC__) && !defined(__UCLIBC__)
68 syntax error here
69 #endif
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +000070 " >"$tempname".c
Denys Vlasenko58d0e202015-10-20 16:40:43 +020071 ! $CC $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1
Denys Vlasenkobca4ea82017-01-24 20:52:42 +010072 exitcode=$?
Denys Vlasenko51340102015-10-20 16:16:16 +020073 rm -f "$tempname" "$tempname".c "$tempname".o
Denys Vlasenkobca4ea82017-01-24 20:52:42 +010074 return $exitcode
Denis Vlasenko3f9c8482007-12-28 17:04:42 +000075}
76
Denis Vlasenko32404742007-10-07 17:05:22 +000077EXE="$1"
78CC="$2"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +000079CFLAGS="$3"
80LDFLAGS="$4"
81O_FILES="$5"
82A_FILES="$6"
83LDLIBS="$7"
Denis Vlasenko32404742007-10-07 17:05:22 +000084
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +000085# The --sort-section option is not supported by older versions of ld
Denys Vlasenko51340102015-10-20 16:16:16 +020086SORT_SECTION="-Wl,--sort-section,alignment"
87if ! check_cc "-Wl,--sort-section,alignment"; then
88 echo "Your linker does not support --sort-section,alignment"
89 SORT_SECTION=""
90fi
Denis Vlasenko130f5592007-11-13 17:36:12 +000091
Dan Fandrichebeac162010-06-18 22:36:10 -070092START_GROUP="-Wl,--start-group"
93END_GROUP="-Wl,--end-group"
Denys Vlasenko367a55c2017-07-15 14:52:26 +020094INFO_OPTS() {
95 echo "-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
96}
Dan Fandrichebeac162010-06-18 22:36:10 -070097
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +020098# gold may not support --sort-common (yet)
Denys Vlasenko51340102015-10-20 16:16:16 +020099SORT_COMMON="-Wl,--sort-common"
100if ! check_cc "-Wl,--sort-common"; then
101 echo "Your linker does not support --sort-common"
102 SORT_COMMON=""
103fi
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200104
Denis Vlasenko3f9c8482007-12-28 17:04:42 +0000105# Static linking against glibc produces buggy executables
106# (glibc does not cope well with ld --gc-sections).
107# See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
108# Note that glibc is unsuitable for static linking anyway.
109# We are removing -Wl,--gc-sections from link command line.
Denys Vlasenko51340102015-10-20 16:16:16 +0200110GC_SECTIONS="-Wl,--gc-sections"
111if (. ./.config && test x"$CONFIG_STATIC" = x"y") then
112 if check_libc_is_glibc; then
113 echo "Static linking against glibc, can't use --gc-sections"
114 GC_SECTIONS=""
115 fi
Denis Vlasenko3f9c8482007-12-28 17:04:42 +0000116fi
Denys Vlasenkoeb1cda22009-06-27 00:24:35 +0200117# The --gc-sections option is not supported by older versions of ld
118if test -n "$GC_SECTIONS"; then
Denys Vlasenko51340102015-10-20 16:16:16 +0200119 if ! check_cc "$GC_SECTIONS"; then
120 echo "Your linker does not support $GC_SECTIONS"
121 GC_SECTIONS=""
122 fi
Denys Vlasenkoeb1cda22009-06-27 00:24:35 +0200123fi
124
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000125# Sanitize lib list (dups, extra spaces etc)
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000126LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000127
128# First link with all libs. If it fails, bail out
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000129echo "Trying libraries: $LDLIBS"
Denis Vlasenko32404742007-10-07 17:05:22 +0000130# "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
Mike Frysinger3eab2b72013-09-12 00:29:40 -0400131l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
Dan Fandrichebeac162010-06-18 22:36:10 -0700132test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000133try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000134 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200135 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000136 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000137 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700138 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenko32404742007-10-07 17:05:22 +0000139 $l_list \
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000140|| {
Denis Vlasenko4824cca2008-03-21 18:29:01 +0000141 echo "Failed: $l_list"
Denis Vlasenko32404742007-10-07 17:05:22 +0000142 cat $EXE.out
Denys Vlasenko056e1f52016-04-03 15:38:53 +0200143 echo 'Note: if build needs additional libraries, put them in CONFIG_EXTRA_LDLIBS.'
144 echo 'Example: CONFIG_EXTRA_LDLIBS="pthread dl tirpc audit pam"'
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000145 exit 1
146}
Denis Vlasenko6ca409e2007-08-12 20:58:27 +0000147
Denis Vlasenko8274e062007-08-06 03:41:08 +0000148# Now try to remove each lib and build without it.
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000149# Stop when no lib can be removed.
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000150while test "$LDLIBS"; do
151 $debug && echo "Trying libraries: $LDLIBS"
Denys Vlasenko32511da2018-11-19 20:36:16 +0100152 dropped_non_first_lib=false
153 first_lib=true
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000154 for one in $LDLIBS; do
155 without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
Denis Vlasenko32404742007-10-07 17:05:22 +0000156 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
Mike Frysinger3eab2b72013-09-12 00:29:40 -0400157 l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
Dan Fandrichebeac162010-06-18 22:36:10 -0700158 test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
Bernhard Reutner-Fischer8d91c132007-09-02 14:51:54 +0000159 $debug && echo "Trying -l options: '$l_list'"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000160 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000161 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200162 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000163 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000164 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700165 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenkod19b87e2007-10-09 13:08:02 +0000166 $l_list
Denis Vlasenko32404742007-10-07 17:05:22 +0000167 if test $? = 0; then
Denis Vlasenkob522d692008-08-26 20:09:08 +0000168 echo " Library $one is not needed, excluding it"
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000169 LDLIBS="$without_one"
Denys Vlasenko32511da2018-11-19 20:36:16 +0100170 $first_lib || dropped_non_first_lib=true
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000171 else
Denis Vlasenkob522d692008-08-26 20:09:08 +0000172 echo " Library $one is needed, can't exclude it (yet)"
Denys Vlasenko32511da2018-11-19 20:36:16 +0100173 first_lib=false
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000174 fi
175 done
Denys Vlasenko32511da2018-11-19 20:36:16 +0100176 # We can stop trying to drop libs if either all libs were needed,
177 # or we excluded only the _first_ few.
178 # (else: we dropped some intermediate lib(s), maybe now we can succeed
179 # in dropping some of the preceding ones)
180 $dropped_non_first_lib || break
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000181done
182
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000183# Make the binary with final, minimal list of libs
Mike Frysinger49d15892007-11-18 06:42:56 +0000184echo "Final link with: ${LDLIBS:-<none>}"
Mike Frysinger3eab2b72013-09-12 00:29:40 -0400185l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
Dan Fandrichebeac162010-06-18 22:36:10 -0700186test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000187# --verbose gives us gobs of info to stdout (e.g. linker script used)
188if ! test -f busybox_ldscript; then
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000189 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000190 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200191 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000192 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000193 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700194 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000195 $l_list \
Denys Vlasenko367a55c2017-07-15 14:52:26 +0200196 `INFO_OPTS` \
Denis Vlasenkod19b87e2007-10-09 13:08:02 +0000197 || {
198 cat $EXE.out
199 exit 1
200 }
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000201else
202 echo "Custom linker script 'busybox_ldscript' found, using it"
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000203 # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000204 # .rodata : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
205 # *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
206 # *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000207 # This will eliminate most of the padding (~3kb).
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000208 # Hmm, "ld --sort-section alignment" should do it too.
Denys Vlasenko663d1da2016-04-22 02:00:04 +0200209 #
210 # There is a ld hack which is meant to decrease disk usage
211 # at the cost of more RAM usage (??!!) in standard ld script:
212 # /* Adjust the address for the data segment. We want to adjust up to
213 # the same address within the page on the next page up. */
214 # . = ALIGN (0x1000) - ((0x1000 - .) & (0x1000 - 1)); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
215 # Replace it with:
216 # . = ALIGN (0x1000); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
217 # to unconditionally align .data to the next page boundary,
218 # instead of "next page, plus current offset in this page"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000219 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000220 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200221 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000222 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000223 $GC_SECTIONS \
Bernhard Reutner-Fischer50dbed92008-05-09 12:43:04 +0000224 -Wl,-T,busybox_ldscript \
Dan Fandrichebeac162010-06-18 22:36:10 -0700225 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000226 $l_list \
Denys Vlasenko367a55c2017-07-15 14:52:26 +0200227 `INFO_OPTS` \
Denis Vlasenkod19b87e2007-10-09 13:08:02 +0000228 || {
229 cat $EXE.out
230 exit 1
231 }
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000232fi
Denis Vlasenko32404742007-10-07 17:05:22 +0000233
Denis Vlasenko42e41822007-10-09 18:01:13 +0000234. ./.config
Denis Vlasenko32404742007-10-07 17:05:22 +0000235
Denis Vlasenkodef88982007-10-07 17:06:01 +0000236sharedlib_dir="0_lib"
237
238if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
239 mkdir "$sharedlib_dir" 2>/dev/null
240 test -d "$sharedlib_dir" || {
241 echo "Cannot make directory $sharedlib_dir"
242 exit 1
243 }
244 ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
245
Denys Vlasenko367a55c2017-07-15 14:52:26 +0200246 # Yes, "ld -shared -static" is a thing. It's a shared library which is itself static.
247 LBB_STATIC=""
248 test "$CONFIG_FEATURE_LIBBUSYBOX_STATIC" = y && LBB_STATIC="-Wl,-static"
249
Denis Vlasenkodef88982007-10-07 17:06:01 +0000250 EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000251 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000252 -o $EXE \
Denys Vlasenko367a55c2017-07-15 14:52:26 +0200253 -shared -fPIC $LBB_STATIC \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000254 -Wl,--enable-new-dtags \
255 -Wl,-z,combreloc \
256 -Wl,-soname="libbusybox.so.$BB_VER" \
Denis Vlasenko9b49a5e2007-10-11 10:05:36 +0000257 -Wl,--undefined=lbb_main \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200258 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000259 $SORT_SECTION \
Dan Fandrichebeac162010-06-18 22:36:10 -0700260 $START_GROUP $A_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000261 $l_list \
Denys Vlasenko367a55c2017-07-15 14:52:26 +0200262 `INFO_OPTS` \
Denis Vlasenkodef88982007-10-07 17:06:01 +0000263 || {
264 echo "Linking $EXE failed"
265 cat $EXE.out
266 exit 1
267 }
Denis Vlasenko141750e2007-10-10 10:05:35 +0000268 $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000269 chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
Denis Vlasenkodef88982007-10-07 17:06:01 +0000270 echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
271fi
Denis Vlasenko32404742007-10-07 17:05:22 +0000272
Denis Vlasenkodef88982007-10-07 17:06:01 +0000273if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
274 EXE="$sharedlib_dir/busybox_unstripped"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000275 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000276 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200277 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000278 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000279 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700280 $START_GROUP $O_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000281 -L"$sharedlib_dir" -lbusybox \
Steve Iribarneed607a82011-05-09 01:42:12 +0200282 $l_list \
Denys Vlasenko367a55c2017-07-15 14:52:26 +0200283 `INFO_OPTS` \
Denis Vlasenkodef88982007-10-07 17:06:01 +0000284 || {
285 echo "Linking $EXE failed"
286 cat $EXE.out
287 exit 1
288 }
Denis Vlasenko141750e2007-10-10 10:05:35 +0000289 $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
Denis Vlasenkodef88982007-10-07 17:06:01 +0000290 echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
291fi
Denis Vlasenkof545be02007-10-07 17:06:26 +0000292
293if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
Denis Vlasenkoe9fd69c2007-10-08 22:16:14 +0000294 echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
Denys Vlasenko5fd3ddf2014-04-19 15:04:39 +0200295 gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
Denis Vlasenkof545be02007-10-07 17:06:26 +0000296 | grep -v "^#" \
Denys Vlasenkoea9ebc02016-06-20 12:23:35 +0200297 | grep -v "^ *$" \
Denis Vlasenkoe9fd69c2007-10-08 22:16:14 +0000298 > applet_lst.tmp
Denis Vlasenko642a52d2007-10-07 21:00:41 +0000299 while read name main junk; do
Denis Vlasenkof545be02007-10-07 17:06:26 +0000300
301 echo "\
Denis Vlasenko15cb4a42007-10-11 10:06:26 +0000302void lbb_prepare(const char *applet, char **argv);
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000303int $main(int argc, char **argv);
Denis Vlasenkof545be02007-10-07 17:06:26 +0000304
Denis Vlasenkof545be02007-10-07 17:06:26 +0000305int main(int argc, char **argv)
306{
Denis Vlasenko15cb4a42007-10-11 10:06:26 +0000307 lbb_prepare(\"$name\", argv);
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000308 return $main(argc, argv);
Denis Vlasenkof545be02007-10-07 17:06:26 +0000309}
310" >"$sharedlib_dir/applet.c"
311
312 EXE="$sharedlib_dir/$name"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000313 try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000314 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200315 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000316 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000317 $GC_SECTIONS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000318 -L"$sharedlib_dir" -lbusybox \
319 -Wl,--warn-common \
Denis Vlasenkof545be02007-10-07 17:06:26 +0000320 || {
321 echo "Linking $EXE failed"
Denis Vlasenko8d755ad2007-10-09 10:15:41 +0000322 cat $EXE.out
Denis Vlasenkof545be02007-10-07 17:06:26 +0000323 exit 1
324 }
325 rm -- "$sharedlib_dir/applet.c" $EXE.out
Denis Vlasenko141750e2007-10-10 10:05:35 +0000326 $STRIP -s --remove-section=.note --remove-section=.comment $EXE
Denys Vlasenkoe3366d62014-05-03 16:35:15 +0200327 # Let user see that we do something - list the names of created binaries:
328 echo "$EXE"
Denis Vlasenkof545be02007-10-07 17:06:26 +0000329
Denis Vlasenkoe9fd69c2007-10-08 22:16:14 +0000330 done <applet_lst.tmp
Denis Vlasenkof545be02007-10-07 17:06:26 +0000331fi
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000332
333# libbusybox.so is needed only for -lbusybox at link time,
334# it is not needed at runtime. Deleting to reduce confusion.
Denis Vlasenko8d755ad2007-10-09 10:15:41 +0000335rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
336exit 0 # or else we may confuse make